
<script setup>
import { ref } from "@vue/reactivity";
import { computed } from "@vue/runtime-core";
const store=ref({
  firstName:"Abdul",
  lastName:"Hamzan"
});

const firtName=ref("Malik");
const lastName=ref("Udin");

const fullNamee=computed({
  get(){
    return firtName.value+" "+lastName.value;
  },
  set(val){
    [firtName.value,lastName.value]=val.split(" ");

  }
});

const changeName=()=>{
  fullNamee.value="Abdul hamzan"

}


const product=ref([
  {
    name:"baju",
    price:1000
  },
  {
    name:"sepatu",
    price:2000
  },
  {
    name:"jaket",
    price:5000
  }
])
const fullNameMe=computed(()=>{
  return store.value.firstName+" "+store.value.lastName
});

const totalPrice=computed(()=>{
  return product.value.reduce((total,number)=>total+number.price,0);
});
const expernsiveProduct=computed(()=>{
  return product.value.filter(item=>item.price>2000);
})

const data=ref({
  name:"Abdul",
  count:0
});
const fullName=ref({
  firstName:"",
  lastName:""
});
const name=ref({
  firstName:"",
  lastName:""
});
const formName=ref({
  name:"",
  profile:"",
  city:"",
  remoteWork:false,
  skill:[],
  age:null

});


const convertName=(param)=>{

  data.value={...data.value,name:param}
}
const increment=(param1,...rest)=>{
  console.log("rest:",rest);
  console.log("param1:",param1);
  data.value={...data.value,count:data.value.count+=1}
}

const decrement=()=>{
   
  data.value={...data.value,count:data.value.count-=1}
}

const save=()=>{

  console.log(fullName.value);
}

const handleAdd=()=>{
  console.log(name.value);

}

const handleSubmit=(e)=>{
  e.preventDefault();
  
  console.log(formName.value);
}


</script>
<template>

  <h2>{{data.name}}</h2>
  <h2>{{data.count}}</h2>
  <button @click="()=>convertName('Malik')">malik</button>
  <button v-on:mouseover="()=>convertName('Abdul')">abdul</button>
  <button v-on:click="()=>increment(1,2,3,4,5)">increment</button>
  <button v-on:click="()=>decrement()">decrement</button>

  <h2>============== form event ==================== cara 1</h2>
  <input :value="fullName.firstName" type="text" @input="e=> fullName.firstName=e.target.value" />
  <input :value="fullName.lastName" type="text" @input="e=> fullName.lastName=e.target.value"  />
  <button @click="save">save</button>

  <h2>============== form event ==================== cara 2 using v-model</h2>
  <input  type="text" v-model="name.firstName" />
  <input type="text" v-model="name.lastName"  />
  <button @click="handleAdd">Add</button>
  <h3>================ form handling============</h3>
  <h2>{{JSON.stringify(formName)}}</h2>
  <form @submit.prevent="handleSubmit" >
    <div>
    <label for="name">Name:</label>
    <input type="text" id="name" v-model="formName.name" placeholder="input name"/>
  </div>
  <div>
    <label for="name">Profile:</label>
    <textarea type="text" id="profile" v-model="formName.profile" placeholder="input name"/>
  </div>
 <div>
  <label for="city">City:</label>
  <select  id="city" v-model="formName.city">
    <option disabled value="">selected city</option>
    <option value="indonesia">Indonesia</option>
    <option value="malaysia">malaysia</option>
    <option value="laos">Laos</option>
  </select>
 </div>
 <div>
  <div>
    <input id="remote" type="checkbox" v-model="formName.remoteWork">
    <label for="remote"> Open to work ? </label>
  </div>
  <div>
    <h5>Skill set</h5>
    <div>
    <input type="checkbox"  id="html" v-model="formName.skill" value="html">
    <label for="html">Html</label>
    <input type="checkbox"  id="css" v-model="formName.skill" value="css">
    <label for="css">Css</label>
  </div>
  <div>
    <label  for="age">Age:</label>
    <input type="number" id="age" placeholder="input your age" v-model.number="formName.age">
  </div>

  </div>
  <button type="submit">Submit</button>
 </div>
  </form>

  <h2>==========computed===========</h2>
  <h2>{{fullNameMe}}</h2>
  <h2>Total belanja saya adalah Rp.{{totalPrice}}</h2>

   <h2>===== Always Learning ======</h2>
   <template v-for="p in product" :key="p.name">
    <div v-if="p.price>2000">
      <h2>{{p.name}}-Rp.{{p.price}}</h2>

    </div>

   </template>
   <h2>=== using computed ===</h2>
   <h2 v-for="item in expernsiveProduct" :key="item.name">{{item.name}}-Rp.{{item.price}}</h2>
   <h2>{{firtName}} {{lastName}}</h2>
   <button @click="changeName">Change Name</button>


  
</template>

<style scoped>

</style>
